"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import sentry_protos.snuba.v1.request_common_pb2
import sentry_protos.snuba.v1.trace_item_attribute_pb2
import sentry_protos.snuba.v1.trace_item_filter_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class TraceItemTableRequest(google.protobuf.message.Message):
    """This is a request to the TraceItemTable endpoint,
    it is used to query for TraceItems (ex. spans)
    it returns tabular data where each row is a TraceItem,
    and the columns are the attributes of the TraceItem
    it can also be used for aggregations
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class OrderBy(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        COLUMN_FIELD_NUMBER: builtins.int
        DESCENDING_FIELD_NUMBER: builtins.int
        descending: builtins.bool
        @property
        def column(self) -> global___Column: ...
        def __init__(
            self,
            *,
            column: global___Column | None = ...,
            descending: builtins.bool = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["column", b"column"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["column", b"column", "descending", b"descending"]) -> None: ...

    META_FIELD_NUMBER: builtins.int
    COLUMNS_FIELD_NUMBER: builtins.int
    FILTER_FIELD_NUMBER: builtins.int
    ORDER_BY_FIELD_NUMBER: builtins.int
    GROUP_BY_FIELD_NUMBER: builtins.int
    LIMIT_FIELD_NUMBER: builtins.int
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    VIRTUAL_COLUMN_CONTEXTS_FIELD_NUMBER: builtins.int
    AGGREGATION_FILTER_FIELD_NUMBER: builtins.int
    limit: builtins.int
    @property
    def meta(self) -> sentry_protos.snuba.v1.request_common_pb2.RequestMeta: ...
    @property
    def columns(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Column]:
        """the columns or aggregations you want to get"""

    @property
    def filter(self) -> sentry_protos.snuba.v1.trace_item_filter_pb2.TraceItemFilter:
        """filter out trace items you dont want"""

    @property
    def order_by(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___TraceItemTableRequest.OrderBy]: ...
    @property
    def group_by(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[sentry_protos.snuba.v1.trace_item_attribute_pb2.AttributeKey]: ...
    @property
    def page_token(self) -> sentry_protos.snuba.v1.request_common_pb2.PageToken:
        """optional, used for pagination, the next page token will be returned in the response"""

    @property
    def virtual_column_contexts(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[sentry_protos.snuba.v1.trace_item_attribute_pb2.VirtualColumnContext]: ...
    @property
    def aggregation_filter(self) -> global___AggregationFilter:
        """filter out results using aggregate functions"""

    def __init__(
        self,
        *,
        meta: sentry_protos.snuba.v1.request_common_pb2.RequestMeta | None = ...,
        columns: collections.abc.Iterable[global___Column] | None = ...,
        filter: sentry_protos.snuba.v1.trace_item_filter_pb2.TraceItemFilter | None = ...,
        order_by: collections.abc.Iterable[global___TraceItemTableRequest.OrderBy] | None = ...,
        group_by: collections.abc.Iterable[sentry_protos.snuba.v1.trace_item_attribute_pb2.AttributeKey] | None = ...,
        limit: builtins.int = ...,
        page_token: sentry_protos.snuba.v1.request_common_pb2.PageToken | None = ...,
        virtual_column_contexts: collections.abc.Iterable[sentry_protos.snuba.v1.trace_item_attribute_pb2.VirtualColumnContext] | None = ...,
        aggregation_filter: global___AggregationFilter | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["aggregation_filter", b"aggregation_filter", "filter", b"filter", "meta", b"meta", "page_token", b"page_token"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["aggregation_filter", b"aggregation_filter", "columns", b"columns", "filter", b"filter", "group_by", b"group_by", "limit", b"limit", "meta", b"meta", "order_by", b"order_by", "page_token", b"page_token", "virtual_column_contexts", b"virtual_column_contexts"]) -> None: ...

global___TraceItemTableRequest = TraceItemTableRequest

@typing.final
class AggregationAndFilter(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FILTERS_FIELD_NUMBER: builtins.int
    @property
    def filters(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___AggregationFilter]: ...
    def __init__(
        self,
        *,
        filters: collections.abc.Iterable[global___AggregationFilter] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["filters", b"filters"]) -> None: ...

global___AggregationAndFilter = AggregationAndFilter

@typing.final
class AggregationOrFilter(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FILTERS_FIELD_NUMBER: builtins.int
    @property
    def filters(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___AggregationFilter]: ...
    def __init__(
        self,
        *,
        filters: collections.abc.Iterable[global___AggregationFilter] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["filters", b"filters"]) -> None: ...

global___AggregationOrFilter = AggregationOrFilter

@typing.final
class AggregationComparisonFilter(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _Op:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _OpEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[AggregationComparisonFilter._Op.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        OP_UNSPECIFIED: AggregationComparisonFilter._Op.ValueType  # 0
        OP_LESS_THAN: AggregationComparisonFilter._Op.ValueType  # 1
        OP_GREATER_THAN: AggregationComparisonFilter._Op.ValueType  # 2
        OP_LESS_THAN_OR_EQUALS: AggregationComparisonFilter._Op.ValueType  # 3
        OP_GREATER_THAN_OR_EQUALS: AggregationComparisonFilter._Op.ValueType  # 4
        OP_EQUALS: AggregationComparisonFilter._Op.ValueType  # 5
        OP_NOT_EQUALS: AggregationComparisonFilter._Op.ValueType  # 6

    class Op(_Op, metaclass=_OpEnumTypeWrapper): ...
    OP_UNSPECIFIED: AggregationComparisonFilter.Op.ValueType  # 0
    OP_LESS_THAN: AggregationComparisonFilter.Op.ValueType  # 1
    OP_GREATER_THAN: AggregationComparisonFilter.Op.ValueType  # 2
    OP_LESS_THAN_OR_EQUALS: AggregationComparisonFilter.Op.ValueType  # 3
    OP_GREATER_THAN_OR_EQUALS: AggregationComparisonFilter.Op.ValueType  # 4
    OP_EQUALS: AggregationComparisonFilter.Op.ValueType  # 5
    OP_NOT_EQUALS: AggregationComparisonFilter.Op.ValueType  # 6

    COLUMN_FIELD_NUMBER: builtins.int
    OP_FIELD_NUMBER: builtins.int
    VALUE_FIELD_NUMBER: builtins.int
    op: global___AggregationComparisonFilter.Op.ValueType
    @property
    def column(self) -> global___Column: ...
    @property
    def value(self) -> sentry_protos.snuba.v1.trace_item_attribute_pb2.AttributeValue: ...
    def __init__(
        self,
        *,
        column: global___Column | None = ...,
        op: global___AggregationComparisonFilter.Op.ValueType = ...,
        value: sentry_protos.snuba.v1.trace_item_attribute_pb2.AttributeValue | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["column", b"column", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["column", b"column", "op", b"op", "value", b"value"]) -> None: ...

global___AggregationComparisonFilter = AggregationComparisonFilter

@typing.final
class AggregationFilter(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AND_FILTER_FIELD_NUMBER: builtins.int
    OR_FILTER_FIELD_NUMBER: builtins.int
    COMPARISON_FILTER_FIELD_NUMBER: builtins.int
    @property
    def and_filter(self) -> global___AggregationAndFilter: ...
    @property
    def or_filter(self) -> global___AggregationOrFilter: ...
    @property
    def comparison_filter(self) -> global___AggregationComparisonFilter: ...
    def __init__(
        self,
        *,
        and_filter: global___AggregationAndFilter | None = ...,
        or_filter: global___AggregationOrFilter | None = ...,
        comparison_filter: global___AggregationComparisonFilter | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["and_filter", b"and_filter", "comparison_filter", b"comparison_filter", "or_filter", b"or_filter", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["and_filter", b"and_filter", "comparison_filter", b"comparison_filter", "or_filter", b"or_filter", "value", b"value"]) -> None: ...
    def WhichOneof(self, oneof_group: typing.Literal["value", b"value"]) -> typing.Literal["and_filter", "or_filter", "comparison_filter"] | None: ...

global___AggregationFilter = AggregationFilter

@typing.final
class Column(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    AGGREGATION_FIELD_NUMBER: builtins.int
    LABEL_FIELD_NUMBER: builtins.int
    label: builtins.str
    @property
    def key(self) -> sentry_protos.snuba.v1.trace_item_attribute_pb2.AttributeKey: ...
    @property
    def aggregation(self) -> sentry_protos.snuba.v1.trace_item_attribute_pb2.AttributeAggregation: ...
    def __init__(
        self,
        *,
        key: sentry_protos.snuba.v1.trace_item_attribute_pb2.AttributeKey | None = ...,
        aggregation: sentry_protos.snuba.v1.trace_item_attribute_pb2.AttributeAggregation | None = ...,
        label: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["aggregation", b"aggregation", "column", b"column", "key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["aggregation", b"aggregation", "column", b"column", "key", b"key", "label", b"label"]) -> None: ...
    def WhichOneof(self, oneof_group: typing.Literal["column", b"column"]) -> typing.Literal["key", "aggregation"] | None: ...

global___Column = Column

@typing.final
class TraceItemColumnValues(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ATTRIBUTE_NAME_FIELD_NUMBER: builtins.int
    RESULTS_FIELD_NUMBER: builtins.int
    RELIABILITIES_FIELD_NUMBER: builtins.int
    attribute_name: builtins.str
    @property
    def results(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[sentry_protos.snuba.v1.trace_item_attribute_pb2.AttributeValue]: ...
    @property
    def reliabilities(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[sentry_protos.snuba.v1.trace_item_attribute_pb2.Reliability.ValueType]:
        """reliability of the values based on confidence interval and sample size math"""

    def __init__(
        self,
        *,
        attribute_name: builtins.str = ...,
        results: collections.abc.Iterable[sentry_protos.snuba.v1.trace_item_attribute_pb2.AttributeValue] | None = ...,
        reliabilities: collections.abc.Iterable[sentry_protos.snuba.v1.trace_item_attribute_pb2.Reliability.ValueType] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["attribute_name", b"attribute_name", "reliabilities", b"reliabilities", "results", b"results"]) -> None: ...

global___TraceItemColumnValues = TraceItemColumnValues

@typing.final
class TraceItemTableResponse(google.protobuf.message.Message):
    """this is a response from the TraceItemTable endpoint
    it is the counterpart to TraceItemTableRequest
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    COLUMN_VALUES_FIELD_NUMBER: builtins.int
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    META_FIELD_NUMBER: builtins.int
    @property
    def column_values(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___TraceItemColumnValues]:
        """the rows"""

    @property
    def page_token(self) -> sentry_protos.snuba.v1.request_common_pb2.PageToken:
        """page token for the next page of results"""

    @property
    def meta(self) -> sentry_protos.snuba.v1.request_common_pb2.ResponseMeta: ...
    def __init__(
        self,
        *,
        column_values: collections.abc.Iterable[global___TraceItemColumnValues] | None = ...,
        page_token: sentry_protos.snuba.v1.request_common_pb2.PageToken | None = ...,
        meta: sentry_protos.snuba.v1.request_common_pb2.ResponseMeta | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["meta", b"meta", "page_token", b"page_token"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["column_values", b"column_values", "meta", b"meta", "page_token", b"page_token"]) -> None: ...

global___TraceItemTableResponse = TraceItemTableResponse
